#include <ctype.h>  /* NOLINT */
#include <stdio.h>  /* NOLINT */
#include <stdlib.h> /* NOLINT */
#include <string.h> /* NOLINT */
#include <time.h>   /* NOLINT */

#if defined(_MSC_VER)
#pragma warning(disable : 4996) /* deprecation */
#endif



/* Forward declare test functions. */
int sdkutils_library_test(int, char*[]);
int aws_profile_early_property_parse_failure_test(int, char*[]);
int aws_profile_missing_bracket_parse_failure_test(int, char*[]);
int aws_profile_missing_assignment_parse_failure_test(int, char*[]);
int aws_profile_missing_property_key_parse_failure_test(int, char*[]);
int aws_profile_early_continuation_parse_failure_test(int, char*[]);
int aws_profile_illegal_continuation1_parse_failure_test(int, char*[]);
int aws_profile_illegal_continuation2_parse_failure_test(int, char*[]);
int aws_profile_illegal_continuation3_parse_failure_test(int, char*[]);
int aws_profile_continuation_reset_on_new_profile_parse_failure_test(int, char*[]);
int aws_profile_empty_test(int, char*[]);
int aws_profile_empty_profile_test(int, char*[]);
int aws_profile_whitespace_empty_profile_test(int, char*[]);
int aws_profile_tab_empty_profile_test(int, char*[]);
int aws_profile_single_simple_property_profile_test(int, char*[]);
int aws_profile_equal_containing_property_profile_test(int, char*[]);
int aws_profile_unicode_containing_property_profile_test(int, char*[]);
int aws_profile_multiple_property_profile_test(int, char*[]);
int aws_profile_trimmable_property_profile_test(int, char*[]);
int aws_profile_empty_property_profile_test(int, char*[]);
int aws_profile_multiple_empty_profile_test(int, char*[]);
int aws_profile_multiple_profile_test(int, char*[]);
int aws_profile_multiple_profile_with_sso_session_test(int, char*[]);
int aws_profile_sso_session_in_credentials_test(int, char*[]);
int aws_profile_sso_session_without_name_test(int, char*[]);
int aws_profile_blank_lines_ignored_test(int, char*[]);
int aws_profile_pound_comments_ignored_test(int, char*[]);
int aws_profile_semicolon_comments_ignored_test(int, char*[]);
int aws_profile_mixed_comments_ignored_test(int, char*[]);
int aws_profile_empty_comments_ignored_test(int, char*[]);
int aws_profile_profile_adjacent_comment_test(int, char*[]);
int aws_profile_value_adjacent_comment_test(int, char*[]);
int aws_profile_continued_property_value_test(int, char*[]);
int aws_profile_multiline_continued_property_value_test(int, char*[]);
int aws_profile_continued_property_value_trim_test(int, char*[]);
int aws_profile_continued_property_value_pound_comment_test(int, char*[]);
int aws_profile_continued_property_value_semicolon_comment_test(int, char*[]);
int aws_profile_duplicate_profiles_merge_test(int, char*[]);
int aws_profile_duplicate_properties_last_property_value_test(int, char*[]);
int aws_profile_duplicate_profiles_last_property_value_test(int, char*[]);
int aws_profile_duplicate_default_profiles_property_resolution1_test(int, char*[]);
int aws_profile_duplicate_default_profiles_property_resolution2_test(int, char*[]);
int aws_profile_invalid_profile_names_merge_test(int, char*[]);
int aws_profile_invalid_property_names_ignored_test(int, char*[]);
int aws_profile_all_valid_profile_characters_test(int, char*[]);
int aws_profile_all_valid_property_characters_test(int, char*[]);
int aws_profile_basic_sub_property_test(int, char*[]);
int aws_profile_empty_sub_property_test(int, char*[]);
int aws_profile_invalid_sub_property_name_test(int, char*[]);
int aws_profile_sub_property_blank_line_test(int, char*[]);
int aws_profile_basic_duplicate_merge_test(int, char*[]);
int aws_profile_mixed_prefix_default_test(int, char*[]);
int aws_profile_override_duplicate_merge_test(int, char*[]);
int aws_profile_no_prefix_nondefault_test(int, char*[]);
int aws_profile_prefix_credentials_test(int, char*[]);
int parse_resource_name_test(int, char*[]);
int parse_resource_name_failures_test(int, char*[]);
int resource_name_tostring_test(int, char*[]);
int resource_name_tostring_failure_test(int, char*[]);
int resource_name_length_test(int, char*[]);
int parse_ruleset_from_string(int, char*[]);
int test_endpoints_aws_region(int, char*[]);
int test_endpoints_default_values(int, char*[]);
int test_endpoints_eventbridge(int, char*[]);
int test_endpoints_fns(int, char*[]);
int test_endpoints_get_attr_type_inference(int, char*[]);
int test_endpoints_headers(int, char*[]);
int test_endpoints_is_virtual_hostable_s3_bucket(int, char*[]);
int test_endpoints_region_override(int, char*[]);
int test_endpoints_minimal_ruleset(int, char*[]);
int test_endpoints_parse_arn(int, char*[]);
int test_endpoints_parse_url(int, char*[]);
int test_endpoints_partition_fn(int, char*[]);
int test_endpoints_substring(int, char*[]);
int test_endpoints_uri_encode(int, char*[]);
int test_endpoints_valid_hostlabel(int, char*[]);
int test_endpoints_condition_mem_clean_up(int, char*[]);
int test_endpoints_custom(int, char*[]);
int test_endpoints_string_array(int, char*[]);
int endpoints_uri_normalize_path(int, char*[]);
int endpoints_byte_buf_init_from_resolved_templated_string(int, char*[]);
int endpoints_regex_aws_region_matches(int, char*[]);
int endpoints_regex_iso_region_matches(int, char*[]);
int endpoints_regex_misc_validation(int, char*[]);


#ifdef __cplusplus
#  define CM_CAST(TYPE, EXPR) static_cast<TYPE>(EXPR)
#  if __cplusplus >= 201103L
#    define CM_NULL nullptr
#  else
#    define CM_NULL NULL
#  endif
#  define CM_NAMESPACE_BEGIN namespace {
#  define CM_NAMESPACE_END }
#  define CM_LOCAL
#else
#  define CM_CAST(TYPE, EXPR) (TYPE)(EXPR)
#  define CM_NULL NULL
#  define CM_NAMESPACE_BEGIN
#  define CM_NAMESPACE_END
#  define CM_LOCAL static
#endif

CM_NAMESPACE_BEGIN

/* Create map.  */

typedef int (*MainFuncPointer)(int, char* []); /* NOLINT */
typedef struct /* NOLINT */
{
  const char* name;
  MainFuncPointer func;
} functionMapEntry;

CM_LOCAL const functionMapEntry cmakeGeneratedFunctionMapEntries[] = {
    {
    "sdkutils_library_test",
    sdkutils_library_test
  },
  {
    "aws_profile_early_property_parse_failure_test",
    aws_profile_early_property_parse_failure_test
  },
  {
    "aws_profile_missing_bracket_parse_failure_test",
    aws_profile_missing_bracket_parse_failure_test
  },
  {
    "aws_profile_missing_assignment_parse_failure_test",
    aws_profile_missing_assignment_parse_failure_test
  },
  {
    "aws_profile_missing_property_key_parse_failure_test",
    aws_profile_missing_property_key_parse_failure_test
  },
  {
    "aws_profile_early_continuation_parse_failure_test",
    aws_profile_early_continuation_parse_failure_test
  },
  {
    "aws_profile_illegal_continuation1_parse_failure_test",
    aws_profile_illegal_continuation1_parse_failure_test
  },
  {
    "aws_profile_illegal_continuation2_parse_failure_test",
    aws_profile_illegal_continuation2_parse_failure_test
  },
  {
    "aws_profile_illegal_continuation3_parse_failure_test",
    aws_profile_illegal_continuation3_parse_failure_test
  },
  {
    "aws_profile_continuation_reset_on_new_profile_parse_failure_test",
    aws_profile_continuation_reset_on_new_profile_parse_failure_test
  },
  {
    "aws_profile_empty_test",
    aws_profile_empty_test
  },
  {
    "aws_profile_empty_profile_test",
    aws_profile_empty_profile_test
  },
  {
    "aws_profile_whitespace_empty_profile_test",
    aws_profile_whitespace_empty_profile_test
  },
  {
    "aws_profile_tab_empty_profile_test",
    aws_profile_tab_empty_profile_test
  },
  {
    "aws_profile_single_simple_property_profile_test",
    aws_profile_single_simple_property_profile_test
  },
  {
    "aws_profile_equal_containing_property_profile_test",
    aws_profile_equal_containing_property_profile_test
  },
  {
    "aws_profile_unicode_containing_property_profile_test",
    aws_profile_unicode_containing_property_profile_test
  },
  {
    "aws_profile_multiple_property_profile_test",
    aws_profile_multiple_property_profile_test
  },
  {
    "aws_profile_trimmable_property_profile_test",
    aws_profile_trimmable_property_profile_test
  },
  {
    "aws_profile_empty_property_profile_test",
    aws_profile_empty_property_profile_test
  },
  {
    "aws_profile_multiple_empty_profile_test",
    aws_profile_multiple_empty_profile_test
  },
  {
    "aws_profile_multiple_profile_test",
    aws_profile_multiple_profile_test
  },
  {
    "aws_profile_multiple_profile_with_sso_session_test",
    aws_profile_multiple_profile_with_sso_session_test
  },
  {
    "aws_profile_sso_session_in_credentials_test",
    aws_profile_sso_session_in_credentials_test
  },
  {
    "aws_profile_sso_session_without_name_test",
    aws_profile_sso_session_without_name_test
  },
  {
    "aws_profile_blank_lines_ignored_test",
    aws_profile_blank_lines_ignored_test
  },
  {
    "aws_profile_pound_comments_ignored_test",
    aws_profile_pound_comments_ignored_test
  },
  {
    "aws_profile_semicolon_comments_ignored_test",
    aws_profile_semicolon_comments_ignored_test
  },
  {
    "aws_profile_mixed_comments_ignored_test",
    aws_profile_mixed_comments_ignored_test
  },
  {
    "aws_profile_empty_comments_ignored_test",
    aws_profile_empty_comments_ignored_test
  },
  {
    "aws_profile_profile_adjacent_comment_test",
    aws_profile_profile_adjacent_comment_test
  },
  {
    "aws_profile_value_adjacent_comment_test",
    aws_profile_value_adjacent_comment_test
  },
  {
    "aws_profile_continued_property_value_test",
    aws_profile_continued_property_value_test
  },
  {
    "aws_profile_multiline_continued_property_value_test",
    aws_profile_multiline_continued_property_value_test
  },
  {
    "aws_profile_continued_property_value_trim_test",
    aws_profile_continued_property_value_trim_test
  },
  {
    "aws_profile_continued_property_value_pound_comment_test",
    aws_profile_continued_property_value_pound_comment_test
  },
  {
    "aws_profile_continued_property_value_semicolon_comment_test",
    aws_profile_continued_property_value_semicolon_comment_test
  },
  {
    "aws_profile_duplicate_profiles_merge_test",
    aws_profile_duplicate_profiles_merge_test
  },
  {
    "aws_profile_duplicate_properties_last_property_value_test",
    aws_profile_duplicate_properties_last_property_value_test
  },
  {
    "aws_profile_duplicate_profiles_last_property_value_test",
    aws_profile_duplicate_profiles_last_property_value_test
  },
  {
    "aws_profile_duplicate_default_profiles_property_resolution1_test",
    aws_profile_duplicate_default_profiles_property_resolution1_test
  },
  {
    "aws_profile_duplicate_default_profiles_property_resolution2_test",
    aws_profile_duplicate_default_profiles_property_resolution2_test
  },
  {
    "aws_profile_invalid_profile_names_merge_test",
    aws_profile_invalid_profile_names_merge_test
  },
  {
    "aws_profile_invalid_property_names_ignored_test",
    aws_profile_invalid_property_names_ignored_test
  },
  {
    "aws_profile_all_valid_profile_characters_test",
    aws_profile_all_valid_profile_characters_test
  },
  {
    "aws_profile_all_valid_property_characters_test",
    aws_profile_all_valid_property_characters_test
  },
  {
    "aws_profile_basic_sub_property_test",
    aws_profile_basic_sub_property_test
  },
  {
    "aws_profile_empty_sub_property_test",
    aws_profile_empty_sub_property_test
  },
  {
    "aws_profile_invalid_sub_property_name_test",
    aws_profile_invalid_sub_property_name_test
  },
  {
    "aws_profile_sub_property_blank_line_test",
    aws_profile_sub_property_blank_line_test
  },
  {
    "aws_profile_basic_duplicate_merge_test",
    aws_profile_basic_duplicate_merge_test
  },
  {
    "aws_profile_mixed_prefix_default_test",
    aws_profile_mixed_prefix_default_test
  },
  {
    "aws_profile_override_duplicate_merge_test",
    aws_profile_override_duplicate_merge_test
  },
  {
    "aws_profile_no_prefix_nondefault_test",
    aws_profile_no_prefix_nondefault_test
  },
  {
    "aws_profile_prefix_credentials_test",
    aws_profile_prefix_credentials_test
  },
  {
    "parse_resource_name_test",
    parse_resource_name_test
  },
  {
    "parse_resource_name_failures_test",
    parse_resource_name_failures_test
  },
  {
    "resource_name_tostring_test",
    resource_name_tostring_test
  },
  {
    "resource_name_tostring_failure_test",
    resource_name_tostring_failure_test
  },
  {
    "resource_name_length_test",
    resource_name_length_test
  },
  {
    "parse_ruleset_from_string",
    parse_ruleset_from_string
  },
  {
    "test_endpoints_aws_region",
    test_endpoints_aws_region
  },
  {
    "test_endpoints_default_values",
    test_endpoints_default_values
  },
  {
    "test_endpoints_eventbridge",
    test_endpoints_eventbridge
  },
  {
    "test_endpoints_fns",
    test_endpoints_fns
  },
  {
    "test_endpoints_get_attr_type_inference",
    test_endpoints_get_attr_type_inference
  },
  {
    "test_endpoints_headers",
    test_endpoints_headers
  },
  {
    "test_endpoints_is_virtual_hostable_s3_bucket",
    test_endpoints_is_virtual_hostable_s3_bucket
  },
  {
    "test_endpoints_region_override",
    test_endpoints_region_override
  },
  {
    "test_endpoints_minimal_ruleset",
    test_endpoints_minimal_ruleset
  },
  {
    "test_endpoints_parse_arn",
    test_endpoints_parse_arn
  },
  {
    "test_endpoints_parse_url",
    test_endpoints_parse_url
  },
  {
    "test_endpoints_partition_fn",
    test_endpoints_partition_fn
  },
  {
    "test_endpoints_substring",
    test_endpoints_substring
  },
  {
    "test_endpoints_uri_encode",
    test_endpoints_uri_encode
  },
  {
    "test_endpoints_valid_hostlabel",
    test_endpoints_valid_hostlabel
  },
  {
    "test_endpoints_condition_mem_clean_up",
    test_endpoints_condition_mem_clean_up
  },
  {
    "test_endpoints_custom",
    test_endpoints_custom
  },
  {
    "test_endpoints_string_array",
    test_endpoints_string_array
  },
  {
    "endpoints_uri_normalize_path",
    endpoints_uri_normalize_path
  },
  {
    "endpoints_byte_buf_init_from_resolved_templated_string",
    endpoints_byte_buf_init_from_resolved_templated_string
  },
  {
    "endpoints_regex_aws_region_matches",
    endpoints_regex_aws_region_matches
  },
  {
    "endpoints_regex_iso_region_matches",
    endpoints_regex_iso_region_matches
  },
  {
    "endpoints_regex_misc_validation",
    endpoints_regex_misc_validation
  },

  { CM_NULL, CM_NULL } /* NOLINT */
};

CM_LOCAL const int NumTests = CM_CAST(int,
  sizeof(cmakeGeneratedFunctionMapEntries) / sizeof(functionMapEntry)) - 1;

/* Allocate and create a lowercased copy of string
   (note that it has to be free'd manually) */
CM_LOCAL char* lowercase(const char* string)
{
  char *new_string;
  char *p;
  size_t stringSize;

  stringSize = CM_CAST(size_t, strlen(string) + 1);
  new_string = CM_CAST(char*, malloc(sizeof(char) * stringSize));

  if (new_string == CM_NULL) { /* NOLINT */
    return CM_NULL;            /* NOLINT */
  }
  strcpy(new_string, string);  /* NOLINT */
  for (p = new_string; *p != 0; ++p) {
    *p = CM_CAST(char, tolower(*p));
  }
  return new_string;
}

CM_LOCAL int isTestSkipped(const char *name, int n_skipped_tests, char *skipped_tests[]) {
  int i;
  for (i = 0; i < n_skipped_tests; i++) {
    if (strcmp(name, skipped_tests[i]) == 0) {
      return 1;
    }
  }

  return 0;
}

CM_NAMESPACE_END

int main(int ac, char* av[])
{
  int i;
  int testNum = 0;
  int partial_match;
  int run_all;
  char *arg;
  int testToRun = -1;

  

  /* If no test name was given */
  /* process command line with user function.  */
  if (ac < 2) {
    /* Ask for a test.  */
    printf("Available tests:\n");
    for (i = 0; i < NumTests; ++i) {
      printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
    }
    printf("To run a test, enter the test number: ");
    fflush(stdout);
    if (scanf("%d", &testNum) != 1) {
      printf("Couldn't parse that input as a number\n");
      return -1;
    }
    if (testNum >= NumTests) {
      printf("%3d is an invalid test number.\n", testNum);
      return -1;
    }
    testToRun = testNum;
    ac--;
    av++;
  }
  partial_match = 0;
  run_all = 0;
  arg = CM_NULL; /* NOLINT */
  /* If partial match or running all tests are requested.  */
  if (testToRun == -1 && ac > 1) {
    partial_match = (strcmp(av[1], "-R") == 0) ? 1 : 0;
    run_all = (strcmp(av[1], "-A") == 0) ? 1 : 0;
  }
  if (partial_match != 0 && ac < 3) {
    printf("-R needs an additional parameter.\n");
    return -1;
  }
  if (run_all == 1) {
    clock_t t;
    int status = 0;
    const char* status_message = CM_NULL;
    printf("TAP version 13\n");
    printf("1..%d\n", NumTests);
    for (i = 0; i < NumTests; ++i) {
      const char *name = cmakeGeneratedFunctionMapEntries[i].name;
      if (ac > 2) {
        if (isTestSkipped(name, ac - 2, av + 2) == 1) {
          printf("ok %d %s # SKIP\n", i + 1, name);
          continue;
        }
      }
      t = clock();
      status = (*cmakeGeneratedFunctionMapEntries[i].func)(ac, av);
      t = clock() - t;
      status_message = (status == -1) ? "not ok" : "ok";
      {
        double time_taken = CM_CAST(double, t) / CLOCKS_PER_SEC;
        printf("%s %d %s # %f\n", status_message, i + 1, name, time_taken);
      }
    }
    printf("All tests finished.\n");

    return 0;
  }

  if (testToRun == -1) {
    arg = lowercase(av[1 + partial_match]);
  }
  for (i = 0; i < NumTests && testToRun == -1; ++i) {
    char *test_name = lowercase(cmakeGeneratedFunctionMapEntries[i].name);
    if (partial_match != 0 && strstr(test_name, arg) != CM_NULL) { /* NOLINT */
      testToRun = i;
      ac -= 2;
      av += 2;
    } else if (partial_match == 0 && strcmp(test_name, arg) == 0) {
      testToRun = i;
      ac--;
      av++;
    }
    free(test_name);
  }
  free(arg);
  if (testToRun != -1) {
    int result;

    if (testToRun < 0 || testToRun >= NumTests) {
      printf("testToRun was modified by TestDriver code to an invalid value: "
             "%3d.\n",
             testNum);
      return -1;
    }
    result = (*cmakeGeneratedFunctionMapEntries[testToRun].func)(ac, av);

    return result;
  }

  /* Nothing was run, display the test names.  */
  printf("Available tests:\n");
  for (i = 0; i < NumTests; ++i) {
    printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
  }
  printf("Failed: %s is an invalid test name.\n", av[1]);

  return -1;
}
